               TITLE CIRCASM
               .286
CODE           SEGMENT WORD PUBLIC PARA
               ASSUME  CS:CODE
;---------------------------
PUBLIC PutCircle
;---------------------------
;  Jrgen Petsch / c't 1991
;---------------------------
;  Zeichnet unter TP einen Kreis geschwindigkeitsoptimiert ohne
;  Verwendung von Winkelfunktionen.
;
;  Die fr den Punkt (2) berechneten        (3)      (2)
;  Mittelpunktabstnde PX,PY lassen               
;  sich durch Drehung und Spiegelung     (7)            (6)
;  fr 8 Punkte verwenden.                        
;                                      
;  Koordinaten (1) = XM+PX, YM+PY                 
;  Koordinaten (2) = XM+PX, YM-PY        (8)            (5)
;  Koordinaten (5) = XM+PY, YM+PX                 
;  usw.                                     (4)      (1)
;
;  Aufruf aus TP: PutCircle (XM, YM, R, Farbe)
;
;  Lage der bergebenen Variablen auf dem Stack:
;
XM             EQU     BP+12
YM             EQU     BP+10
R              EQU     BP+8
Farbe          EQU     BP+6
;
;  Lokale Variable auf dem Stack:
;
PX             EQU     BP-2
PY             EQU     BP-4
;----------------------------------
PutCircle      PROC    FAR
               PUSH    BP

               MOV     BP,SP
               SUB     SP,4        ; Platz fr 2 lokale Integer
               PUSH    DS
;
;  Setze ENABLE_SET_RES_REG:= 0F und SET_RES_REG:= FARBE
;
               MOV     DX,3CEH
               MOV     AX,0F01h    ; ENABLE_SET_RES_REG:= 0F
               OUT     DX,AX
               MOV     AL,0        ; -> SET_RESET_REG
               MOV     AH,[FARBE]
               OUT     DX,AX       ; SET_RES_REG:= FARBE
               MOV     AL,8        ; -> BIT_MASK_REG
               OUT     DX,AL
               INC     DX          ; DX -> 3CFh
;
;  DS -> Screen-Segm fr Zugriff ohne Overwright
;
               MOV     AX,0A000h
               MOV     DS,AX
;
;  Beginne mit PX:= 0, PY:= R  und A:= R
;
               SUB      BX,BX      ; BX:= PX := 0
               MOV      CX,[R]     ; PY:= R
               MOV      SI,CX      ; SI:= A := R
;.................
;  Hauptschleife
;  Verwendung der Register:
;   DX-> 3CFh
;   BP-> Variable auf dem Stack [PX] [PY] [XM] [YM]
;.................
;
;  Wenn A < 0, dann PY:= PY - 1 und A:= A + PY + PY
;
               EVEN                ; Optimiere Codezugriff
PutCircle_2:   OR      SI,SI       ; A < 0 ?
               JNS     PutCircle_4 ;   Nein, berspringe
               DEC     CX          ; PY:= PY - 1
               ADD     SI,CX
               ADD     SI,CX       ; A:= A + PY + PY
;..................................
;  Zeichne 8 Punkte des Kreises
;..................................
;
;  Rette A, PY und PX
;
               EVEN                ; Optimiere Codezugriff
PutCircle_4:   PUSH    SI          ; Rette A
               MOV     [PY],CX     ; Rette PY
               MOV     [PX],BX     ; Rette PX
;
;  Zeichne (1)      ( BX hat PX )
;
               ADD     BX,[XM]     ; BX:= X1:= XM+PX

               MOV     CX,BX       ; CX:= X1
               AND     CL,7        ; X1 mod 8
               MOV     AL,80h
               SHR     AL,CL       ; Bit_Pos
               OUT     DX,AL       ; ins BIT_MASK_REG

               SHR     BX,3        ; X1/8
               MOV     DI,BX       ; fr spter

               MOV     AX,[YM]
               ADD     AX,[PY]     ; AX = Y1 = YM + PY
               IMUL    AX,80       ; 80*Y1

               ADD     BX,AX       ; Screenadr = X1/8 + 80*Y1
               XCHG    SI,AX       ; 80*Y1 fr spter
               XCHG    [BX],AL     ; Dummy Read/Write
;
;  Zeichne (2)      ( DI hat X1/8 )
;
               MOV     AX,[YM]     ; YM
               SUB     AX,[PY]     ; AX:= Y2:= YM-PY
               IMUL    AX,80       ; 80*Y2
               PUSH    AX          ; fr spter
               ADD     DI,AX       ; Screenadr = X1/8 + 80*Y2
               XCHG    [DI],AL     ; Dummy Read/Write
;
;  Zeichne (3)      ( TOS hat 80*Y2 )
;
               MOV     BX,[XM]     ; XM
               SUB     BX,[PX]     ; BX:= X3:= XM-PX

               MOV     CX,BX       ; CX:= X3
               AND     CL,7        ; X3 mod 8
               MOV     AL,80h
               SHR     AL,CL       ; Bit_Pos
               OUT     DX,AL       ; ins BIT_MASK_REG

               SHR     BX,3        ; X3/8
               MOV     DI,BX       ; fr spter

               POP     AX          ; AX:= 80*Y2
               ADD     BX,AX       ; Screenadr = X3/8 + 80*Y2
               XCHG    [BX],AL     ; Dummy Read/Write
;
;  Zeichne (4)       ( DI hat X3/8 und SI hat 80*Y1 )
;
               ADD     DI,SI       ; Screenadr = X3/8 + 80*Y1
               XCHG    [DI],AL     ; Dummy Read/Write
;
;  Zeichne (5)
;
               MOV     BX,[XM]     ; XM
               ADD     BX,[PY]     ; BX:= X5:= XM+PY

               MOV     CX,BX
               AND     CL,7        ; X5 mod 8
               MOV     AL,80h
               SHR     AL,CL       ; BitPos
               OUT     DX,AL       ; ins BIT_MASK_REG

               SHR     BX,3        ; X5/8
               MOV     DI,BX       ; fr spter

               MOV     AX,[YM]     ; YM
               ADD     AX,[PX]     ; AX:= Y5:= YM+PX
               IMUL    AX,80       ; 80*Y5

               ADD     BX,AX       ; ScreenAdr = X5/8 + 80*Y5
               XCHG    SI,AX       ; 80*Y5 fr spter
               XCHG    [BX],AL     ; Dummy Read/Write
;
;  Zeichne (6)       ( DI hat X5/8 )
;
               MOV     AX,[YM]     ; YM
               SUB     AX,[PX]     ; AX:= Y6:= YM-PX
               IMUL    AX,80       ; 80*Y6
               PUSH    AX          ; fr spter
               ADD     DI,AX       ; ScreenAdr = X5/8 + 80*Y6
               XCHG    [DI],AL     ; Dummy Read/Write
;
;  Zeichne (7)      ( TOS hat 80*Y6 )
;
               MOV     BX,[XM]     ; XM
               SUB     BX,[PY]     ; BX:= X7:= XM-PY
               MOV     CX,BX
               AND     CL,7        ; X7 mod 8
               MOV     AL,80h
               SHR     AL,CL       ; BitPos
               OUT     DX,AL       ; ins BIT_MASK_REG

               SHR     BX,3        ; X7/8
               MOV     DI,BX       ; fr spter

               POP     AX          ; AX:= 80*Y6
               ADD     BX,AX       ; ScreenAdr = X7/8 + 80*Y6
               XCHG    [BX],AL     ; Dummy Read/Write
;
;  Zeichne (8)      ( DI hat X7/8   SI hat 80*Y5 )
;
               ADD     DI,SI       ; ScreenAdr = X7/8 + 80*Y5
               XCHG    [DI],AL     ; Dummy Read/Write
;
;  Restore PX, PY und A
;
               MOV     CX,[PY]     ; CX:= PY
               MOV     BX,[PX]     ; BX:= PX
               POP     SI          ; SI:= A
;
;  Berechne A:= A - PX - PX - 1
;
               SUB     SI,BX       ; A:= A - PX
               SUB     SI,BX       ; A:= A - PX - PX
               DEC     SI          ; A:= A - PX - PX - 1
;
;  PX:= PX + 1.   Loop, solange PX < PY ist
;
               INC     BX          ; PX:= PX +1
               CMP     CX,BX       ; PY <= PX ?
               JBE     PutCircle_0 ;  ja, fertig
               JMP     PutCircle_2 ; Nein, loop
;...............
;  Restore DS und BP und rume den Stack auf.
;
PutCircle_0:   POP     DS          ; TP braucht sein DS
               MOV     SP,BP
               POP     BP          ; und BP unverndert zurck
               RET     8           ; Gib den Platz fr
;                                  ; 4 Integer wieder frei
PutCircle      ENDP
;---------------------------------------
CODE           ENDS
               END
;ENDE CIRCASM.ASM
